Welcome to Subscribe On Youtube

Formatted question description: https://leetcode.ca/all/2261.html

2261. K Divisible Elements Subarrays

  • Difficulty: Medium.
  • Related Topics: Array, Hash Table, Trie, Rolling Hash, Hash Function, Enumeration.
  • Similar Questions: Subarrays with K Different Integers, Count Number of Nice Subarrays, Subarray With Elements Greater Than Varying Threshold.

Problem

Given an integer array nums and two integers k and p, return the number of **distinct subarrays which have at most** k elements divisible by p.

Two arrays nums1 and nums2 are said to be distinct if:

  • They are of different lengths, or

  • There exists at least one index i where nums1[i] != nums2[i].

A subarray is defined as a non-empty contiguous sequence of elements in an array.

  Example 1:

Input: nums = [2,3,3,2,2], k = 2, p = 2
Output: 11
Explanation:
The elements at indices 0, 3, and 4 are divisible by p = 2.
The 11 distinct subarrays which have at most k = 2 elements divisible by 2 are:
[2], [2,3], [2,3,3], [2,3,3,2], [3], [3,3], [3,3,2], [3,3,2,2], [3,2], [3,2,2], and [2,2].
Note that the subarrays [2] and [3] occur more than once in nums, but they should each be counted only once.
The subarray [2,3,3,2,2] should not be counted because it has 3 elements that are divisible by 2.

Example 2:

Input: nums = [1,2,3,4], k = 4, p = 1
Output: 10
Explanation:
All element of nums are divisible by p = 1.
Also, every subarray of nums will have at most 4 elements that are divisible by 1.
Since all subarrays are distinct, the total number of subarrays satisfying all the constraints is 10.

  Constraints:

  • 1 <= nums.length <= 200

  • 1 <= nums[i], p <= 200

  • 1 <= k <= nums.length

  Follow up:

Can you solve this problem in O(n2) time complexity?

Solution (Java, C++, Python)

  • class Solution {
        public int countDistinct(int[] nums, int k, int p) {
            HashSet<Long> numSubarray = new HashSet<>();
            for (int i = 0; i < nums.length; i++) {
                int countDiv = 0;
                long hashCode = 1;
                for (int j = i; j < nums.length; j++) {
                    hashCode = 199L * hashCode + nums[j];
                    if (nums[j] % p == 0) {
                        countDiv++;
                    }
                    if (countDiv <= k) {
                        numSubarray.add(hashCode);
                    } else {
                        break;
                    }
                }
            }
            return numSubarray.size();
        }
    }
    
    ############
    
    class Solution {
        public int countDistinct(int[] nums, int k, int p) {
            int n = nums.length;
            Set<String> s = new HashSet<>();
            for (int i = 0; i < n; ++i) {
                int cnt = 0;
                String t = "";
                for (int j = i; j < n; ++j) {
                    if (nums[j] % p == 0 && ++cnt > k) {
                        break;
                    }
                    t += nums[j] + ",";
                    s.add(t);
                }
            }
            return s.size();
        }
    }
    
  • class Solution:
        def countDistinct(self, nums: List[int], k: int, p: int) -> int:
            n = len(nums)
            s = set()
            for i in range(n):
                cnt = 0
                t = ""
                for j in range(i, n):
                    if nums[j] % p == 0:
                        cnt += 1
                    if cnt <= k:
                        t += str(nums[j]) + ","
                        s.add(t)
                    else:
                        break
            return len(s)
    
    ############
    
    # 2261. K Divisible Elements Subarrays
    # https://leetcode.com/problems/k-divisible-elements-subarrays/
    
    class Solution:
        def countDistinct(self, nums: List[int], k: int, p: int) -> int:
            s = set()
            i = 0
            count = 0
            n = len(nums)
            
            def go(arr, start, end): 
                sub_list = [] 
                
                for i in range(start, end + 1): 
                    for j in range(i + 1, end + 1): 
                        sub = arr[i:j] 
                        sub_list.append(sub) 
    
                return sub_list
        
            for j, x in enumerate(nums):
                if x % p == 0:
                    count += 1
                
                while count > k:
                    if nums[i] % p == 0:
                        count -= 1
                    i += 1
                
                
                if j == n - 1 or count == k:
                    for sub in go(nums, i, j + 1):
                        s.add(tuple(sub))
    
            return len(s)
    
    
  • class Solution {
    public:
        int countDistinct(vector<int>& nums, int k, int p) {
            unordered_set<string> s;
            int n = nums.size();
            for (int i = 0; i < n; ++i) {
                int cnt = 0;
                string t;
                for (int j = i; j < n; ++j) {
                    if (nums[j] % p == 0 && ++cnt > k) {
                        break;
                    }
                    t += to_string(nums[j]) + ",";
                    s.insert(t);
                }
            }
            return s.size();
        }
    };
    
  • func countDistinct(nums []int, k int, p int) int {
    	s := map[string]struct{}{}
    	for i := range nums {
    		cnt, t := 0, ""
    		for _, x := range nums[i:] {
    			if x%p == 0 {
    				cnt++
    				if cnt > k {
    					break
    				}
    			}
    			t += string(x) + ","
    			s[t] = struct{}{}
    		}
    	}
    	return len(s)
    }
    
  • function countDistinct(nums: number[], k: number, p: number): number {
        const n = nums.length;
        const s = new Set();
        for (let i = 0; i < n; ++i) {
            let cnt = 0;
            let t = '';
            for (let j = i; j < n; ++j) {
                if (nums[j] % p === 0 && ++cnt > k) {
                    break;
                }
                t += nums[j].toString() + ',';
                s.add(t);
            }
        }
        return s.size;
    }
    
    

Explain:

nope.

Complexity:

  • Time complexity : O(n).
  • Space complexity : O(n).

All Problems

All Solutions